USE [COWS]
GO
_CreateObject 'SP','tmp','updateMDSEvent'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--=============================================
 --Author:		<Jagan Gangi>
 --Create date: <07/06/2018>
 --Description:	Temp. fix for updating MDS CPE Dev/Dev Mgmt Tables
 --=============================================
ALTER PROCEDURE [tmp].[updateMDSEvent]
AS

BEGIN
BEGIN TRY
	
DECLARE @EventTbl TABLE (EventID INT)
DECLARE @EventID INT
DECLARE @IDs TABLE (ID1 INT, ID2 VARCHAR(100))
DECLARE @ID1 INT
DECLARE @ID2 VARCHAR(100)
DECLARE @ODIEDevNme VARCHAR(1000)
DECLARE @NoteTxt VARCHAR(MAX)=''

SET NOCOUNT ON;

INSERT INTO @EventTbl
SELECT DISTINCT edc.EVENT_ID
FROM COWS.dbo.EVENT_DEV_CMPLT edc WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=edc.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(edc.ODIE_DEV_NME,'') = ''
AND edc.REC_STUS_ID=1
UNION
SELECT DISTINCT ecd.EVENT_ID
FROM COWS.dbo.EVENT_CPE_DEV ecd WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=ecd.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(ecd.ODIE_DEV_NME,'') = ''
AND ecd.REC_STUS_ID=1
UNION
SELECT DISTINCT eds.EVENT_ID
FROM COWS.dbo.EVENT_DEV_SRVC_MGMT eds WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=eds.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(eds.ODIE_DEV_NME,'') = ''
AND eds.REC_STUS_ID=1
UNION
SELECT DISTINCT eds.EVENT_ID
FROM COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT eds WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=eds.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(eds.ODIE_DEV_NME,'') = ''
AND eds.REC_STUS_ID=1
UNION
SELECT DISTINCT eds.EVENT_ID
FROM COWS.dbo.MDS_EVENT_DSL_SBIC_CUST_TRPT eds WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=eds.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(eds.ODIE_DEV_NME,'') = ''
AND eds.REC_STUS_ID=1
UNION
SELECT DISTINCT eds.EVENT_ID
FROM COWS.dbo.MDS_EVENT_PORT_BNDWD eds WITH (NOLOCK) INNER JOIN
COWS.dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=eds.EVENT_ID
WHERE 
me.EVENT_STUS_ID != 8
AND 
ISNULL(eds.ODIE_DEV_NME,'') = ''
AND eds.REC_STUS_ID=1

WHILE EXISTS (SELECT * FROM @EventTbl)
BEGIN
	SELECT TOP 1 @EventID = EventID FROM @EventTbl
	
	--Update Event_Dev_Cmplt
	UPDATE edc
	SET ODIE_DEV_NME=rdi.DEV_NME, ODIE_SENT_DT=NULL
	FROM COWS.dbo.EVENT_DEV_CMPLT edc INNER JOIN
	COWS.dbo.REDSGN_DEVICES_INFO rdi WITH (NOLOCK) ON rdi.REDSGN_DEV_ID=edc.REDSGN_DEV_ID
	WHERE edc.REC_STUS_ID=1 AND rdi.REC_STUS_ID=1
	AND ISNULL(edc.ODIE_DEV_NME,'')=''
	AND edc.EVENT_ID=@EventID
	
	IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
		SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID)
	ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID), @NoteTxt)<=0))
		SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID)

	--UPDATE COWS.dbo.MDS_EVENT_DSL_SBIC_CUST_TRPT
	UPDATE meds
	SET ODIE_DEV_NME=ISNULL((SELECT TOP 1 ODIE_DEV_NME FROM COWS.dbo.MDS_EVENT_DSL_SBIC_CUST_TRPT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'')!='' ORDER BY CREAT_DT DESC),''),
		MODFD_DT = GETDATE()
	FROM COWS.dbo.MDS_EVENT_DSL_SBIC_CUST_TRPT meds
	WHERE meds.REC_STUS_ID=1
	AND ISNULL(meds.ODIE_DEV_NME,'')=''
	AND meds.EVENT_ID=@EventID
	IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
		SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID)
	ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID), @NoteTxt)<=0))
		SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID)

	--UPDATE COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT
	UPDATE mesw
	SET ODIE_DEV_NME=x.ODIE_DEV_NME, MODFD_DT = GETDATE()
	FROM COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT mesw INNER JOIN
	(SELECT DISTINCT IP_NUA_ADR, ODIE_DEV_NME FROM COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'')!='') x ON mesw.IP_NUA_ADR=x.IP_NUA_ADR
	WHERE mesw.REC_STUS_ID=1
	AND ISNULL(mesw.ODIE_DEV_NME,'')=''
	AND mesw.EVENT_ID=@EventID
	IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
		SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID)
	ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID), @NoteTxt)<=0))
		SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID)

	--UPDATE COWS.dbo.MDS_EVENT_PORT_BNDWD
	UPDATE mesw
	SET ODIE_DEV_NME=x.ODIE_DEV_NME, MODFD_DT = GETDATE()
	FROM COWS.dbo.MDS_EVENT_PORT_BNDWD mesw INNER JOIN
	(SELECT DISTINCT M5_ORDR_NBR, M5_ORDR_CMPNT_ID, NUA, ODIE_DEV_NME FROM COWS.dbo.MDS_EVENT_PORT_BNDWD WITH (NOLOCK) WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'')!='') x ON mesw.NUA=x.NUA AND mesw.M5_ORDR_NBR=x.M5_ORDR_NBR AND x.M5_ORDR_CMPNT_ID=mesw.M5_ORDR_CMPNT_ID
	WHERE mesw.REC_STUS_ID=1
	AND ISNULL(mesw.ODIE_DEV_NME,'')=''
	AND mesw.EVENT_ID=@EventID
	IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
		SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID)
	ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID), @NoteTxt)<=0))
		SET @NoteTxt = @NoteTxt+'; EventID='+CONVERT(VARCHAR,@EventID)

	--UPDATE COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT
	INSERT INTO @IDs
	SELECT DISTINCT SLNK_WIRED_TRPT_ID, IP_NUA_ADR FROM COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1 AND ISNULL(ODIE_DEV_NME,'')=''

	WHILE EXISTS (SELECT * FROM @IDs)
	BEGIN
		SELECT TOP 1 @ID1 = ID1, @ID2 = ID2 FROM @IDs
		SELECT TOP 1 @ODIEDevNme = ODIE_DEV_NME FROM COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND IP_NUA_ADR=@ID2 AND ISNULL(ODIE_DEV_NME,'') != '' ORDER BY CREAT_DT DESC

		UPDATE COWS.dbo.MDS_EVENT_SLNK_WIRED_TRPT SET ODIE_DEV_NME=@ODIEDevNme, MODFD_DT = GETDATE() WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'') = '' AND SLNK_WIRED_TRPT_ID=@ID1 AND @ODIEDevNme IS NOT NULL
		IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
			SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; IP_NUA_ADR='+@ID2
		ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; IP_NUA_ADR='+@ID2, @NoteTxt)<=0))
			SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; IP_NUA_ADR='+@ID2
		DELETE FROM @IDs WHERE ID1=@ID1
	END

	DELETE FROM @IDs
	SET @ODIEDevNme=null
	SET @ID1=null
	SET @ID2=null

	--Event_Cpe_Dev
	INSERT INTO @IDs
	SELECT EVENT_CPE_DEV_ID, DEVICE_ID FROM dbo.EVENT_CPE_DEV WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1 AND ISNULL(ODIE_DEV_NME,'')=''

	WHILE EXISTS (SELECT * FROM @IDs)
	BEGIN
		SELECT TOP 1 @ID1 = ID1, @ID2 = ID2 FROM @IDs
		SELECT TOP 1 @ODIEDevNme = ODIE_DEV_NME FROM COWS.dbo.EVENT_CPE_DEV WITH (NOLOCK) WHERE EVENT_ID=@EventID AND DEVICE_ID=@ID2 AND ISNULL(ODIE_DEV_NME,'') != '' ORDER BY CREAT_DT DESC
		IF ((ISNULL(@ODIEDevNme,'')='') AND ((SELECT COUNT(DISTINCT ODIE_DEV_NME) FROM COWS.dbo.EVENT_DEV_CMPLT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1)=1))
			SELECT DISTINCT TOP 1 @ODIEDevNme = ODIE_DEV_NME FROM COWS.dbo.EVENT_DEV_CMPLT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1
		UPDATE COWS.dbo.EVENT_CPE_DEV SET ODIE_DEV_NME=@ODIEDevNme, MODFD_DT = GETDATE() WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'') = '' AND EVENT_CPE_DEV_ID=@ID1 AND @ODIEDevNme IS NOT NULL
		IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
			SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; DEVICE_ID='+@ID2
		ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; DEVICE_ID='+@ID2, @NoteTxt)<=0))
			SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; DEVICE_ID='+@ID2
		DELETE FROM @IDs WHERE ID1=@ID1
	END

	DELETE FROM @IDs
	SET @ODIEDevNme=null
	SET @ID1=null
	SET @ID2=null
	--Event_Dev_Srvc_Mgmt
	INSERT INTO @IDs
	SELECT EVENT_DEV_SRVC_MGMT_ID, M5_ORDR_CMPNT_ID FROM COWS.dbo.EVENT_DEV_SRVC_MGMT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1 AND ISNULL(ODIE_DEV_NME,'')=''

	WHILE EXISTS (SELECT * FROM @IDs)
	BEGIN
		SELECT TOP 1 @ID1 = ID1, @ID2 = ID2 FROM @IDs
		SELECT TOP 1 @ODIEDevNme = ODIE_DEV_NME FROM COWS.dbo.EVENT_DEV_SRVC_MGMT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND M5_ORDR_CMPNT_ID=@ID2 AND ISNULL(ODIE_DEV_NME,'') != '' ORDER BY CREAT_DT DESC

		IF ((ISNULL(@ODIEDevNme,'')='') AND ((SELECT COUNT(DISTINCT ODIE_DEV_NME) FROM COWS.dbo.EVENT_DEV_CMPLT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1)=1))
			SELECT DISTINCT TOP 1 @ODIEDevNme = ODIE_DEV_NME FROM COWS.dbo.EVENT_DEV_CMPLT WITH (NOLOCK) WHERE EVENT_ID=@EventID AND REC_STUS_ID=1

		UPDATE COWS.dbo.EVENT_DEV_SRVC_MGMT SET ODIE_DEV_NME=@ODIEDevNme, MODFD_DT = GETDATE() WHERE EVENT_ID=@EventID AND ISNULL(ODIE_DEV_NME,'') = '' AND EVENT_DEV_SRVC_MGMT_ID=@ID1 AND @ODIEDevNme IS NOT NULL
		IF ((@@ROWCOUNT>0) AND (LEN(@NoteTxt)=0))
			SET @NoteTxt = 'EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; M5_ORDR_CMPNT_ID='+@ID2
		ELSE IF ((@@ROWCOUNT>0) AND (CHARINDEX('EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; M5_ORDR_CMPNT_ID='+@ID2, @NoteTxt)<=0))
			SET @NoteTxt = @NoteTxt + '; EventID='+CONVERT(VARCHAR,@EventID) + '; ODIEDevNme='+@ODIEDevNme+'; M5_ORDR_CMPNT_ID='+@ID2
		DELETE FROM @IDs WHERE ID1=@ID1
	END
	
	DELETE FROM @IDs
	SET @ODIEDevNme=null
	SET @ID1=null
	SET @ID2=null
	
	DELETE FROM @EventTbl WHERE EventID=@EventID
END

IF (LEN(@NoteTxt)>0)
	INSERT INTO dbo.SYS_LOG (Notes, Process, CreatDt) VALUES (@NoteTxt, 'MDSEventUpdate', GETDATE())

END TRY
BEGIN CATCH
	EXEC dbo.insertErrorInfo
END CATCH    
END